#include "StdAfx.h"

#include <iostream>

#include "Expr.h"
#include "ExprRep.h"

using namespace std;


Expr::Expr(void): rep(0)
{
}


Expr::Expr(ExprRep* anExprRepP) {

	rep = anExprRepP;
	if (rep)
		rep->refCnt++;
}

Expr::Expr(ExprRep & anExprRep) {

	rep = &anExprRep;
	if (rep)
		rep->refCnt++;
}


Expr::Expr(const Expr & e) {

	rep = e.rep;
	if (rep)
		rep->refCnt++;

}

Expr& Expr::operator= (const Expr & e) {


	if (e.rep)
		e.rep->refCnt++;

	if (rep) {
		rep->refCnt--;
		if (rep->refCnt == 0)
				delete rep;
	};

	rep = e.rep;

 return *this;

}



Expr::~Expr(void)
{
	if (rep) {
		rep->refCnt--;
		if (rep->refCnt == 0)
				delete rep;
	};
}

Expr Expr::eval () {

	return *this;

}

Expr Expr::clone () {
	return Expr(rep->clone());
};

Expr& Expr::setRep (ExprRep* ep) {

	if (rep) {
		rep->refCnt--;
		if (rep->refCnt == 0)
			delete rep;
	};
	rep = ep;
	rep->refCnt++;

	return *this;
};


ExprRep* Expr::getRep () const {
	return rep;
};



void Expr::print(ostream & os) const {
	getRep()->print(os);
};


Expr& Expr::operator[] (const Expr& ind) {
	return (*getRep())[ind];
};

//Expr& Expr::set(const Expr& e) {
//	return getRep()->set(e);
//}



ostream& operator<< (ostream& os, const Expr& e) {
	e.print(os);
	return os;
};


Expr nil;