#pragma once


#include "Expr.h"
class Type;

template<class K, class V>
class HashTableRep;



template<class K, class V>
class HashTable: public Expr
{
public:

	typedef typename HashTableRep<typename K::Rep, typename V::Rep> Rep;

	HashTable(void);
	~HashTable(void);

	V & operator[] (const K & key) {
		return (*getRep())[key];
	};

	HashTableRep<typename K::Rep, typename V::Rep>* getRep() {
		return dynamic_cast<HashTableRep<K::Rep, V::Rep>*>(getRep());
	};
};

Expr makeHashTable(const Type& keyType, const Type& valType);
