#pragma once

#include <map>

#include "ExprRep.h"

#include "Expr.h"
#include "Integer.h"

template<>
class std::less<Expr> {

public:

	bool operator() (const Expr& a, const Expr& b) {

		return a.Expr::getRep() < b.Expr::getRep();

	};
};

template<>
class std::less<Integer> {

public:

	bool operator() (const Integer& a, const Integer& b) {

		return a.getRep() < b.getRep();

	};
};



template<class K, class V>
class HashTableRep: public ExprRep
{
public:

		HashTableRep(void);
		~HashTableRep(void);

		HashTableRep(const HashTableRep & rhs);

		HashTableRep* clone () {
			return new HashTableRep(*this);
		};

		V& operator[] (const Expr& ind ) {

			return theMap[dynamic_cast<const K&>(ind)];
		};

private:

	std::map<K,V> theMap;

};


template<class K, class V>
HashTableRep<K,V>::HashTableRep(void)
{
};

template<class K, class V>
HashTableRep<K,V>::~HashTableRep(void)
{
};

template<class K, class V>
HashTableRep<K,V>::HashTableRep(const HashTableRep<K,V> & rhs): theMap(rhs.theMap) {

};



template<class K, class V>
Expr getHashTable () {
		return Expr(new HashTableRep<K,V>());
};

