#include "StdAfx.h"

#include "RingElemRep.h"

#include "IntegerRep.h"
#include "PolynomialRep.h"

#include "Integer.h"
#include "Polynomial.h"

using namespace std;

IntegerRep::IntegerRep(void)
{
}

IntegerRep::~IntegerRep(void)
{
}


void IntegerRep::print (ostream& os) const {
	bool a, b;
	printRingElement(os, a, b);
}

void IntegerRep::printRingElement(ostream& os, bool& issum, bool& minusleads) const {

	issum = false;
	minusleads = (val < 0);
	os << val;

}

RingElem IntegerRep::negate() { 
	return Integer(-getVal());
}

//
// add and mult don't modify the this-Object
//


RingElem IntegerRep::add(const RingElem& b) { 
	return b->add(Integer(this)); 
}

RingElem IntegerRep::mult(const RingElem& b) { 
	return b->mult(Integer(this)); 
}

RingElem IntegerRep::add(const Integer& b) {
	return Integer(val + b->getVal());
}

RingElem IntegerRep::mult(const Integer& b) {
	return Integer(val * b->getVal());
}

RingElem IntegerRep::add(const Polynomial& b) {
	return b->add(Integer(this));
}

RingElem IntegerRep::mult(const Polynomial& b) {
	return b->mult(Integer(this));
}

//
// addM and multM modify the this-object
//


RingElem IntegerRep::addM(const Integer& b)  {
	val += b->val;
	return Integer(this);
}

RingElem IntegerRep::addM(const Polynomial& b)  {
	throw RingElemOpVirtual();	
}


RingElem IntegerRep::multM(const Integer& b)  {
	val *= b->val;
	return Integer(this);
}

RingElem IntegerRep::multM(const Polynomial& b)  {
	throw RingElemOpVirtual ();
}



RingElem IntegerRep::applyIntMap(const RingMapInt& f) {
	return Integer(this);
}

RingElem IntegerRep::applyPolyMap(const RingMapPoly& f) {
	throw Undefined ();
	return Integer(this);
}
