// Polysim.cpp : Definiert den Einstiegspunkt fr die Konsolenanwendung.
//

#include "stdafx.h"

#include <iostream>
#include <sstream>

#include <string>

#include "Expr.h"
#include "Variable.h"
#include "Integer.h"

#include "Type.h"

#include "Ring.h"
#include "RingRep.h"

#include "RingMap.h"
#include "RingMapRep.h"

#include "VariableRep.h"

#include "RingElem.h"
#include "Polynomial.h"

#include "PolynomialRep.h"


using namespace std;

RingElem sq (RingElem x) {
	return x * x;
};


int _tmain(int argc, _TCHAR* argv[])
{

	cout << "PolySim Polynomial Symbolic Manipulator" << endl << endl << endl;

	int lineCnt = 1;
	{

	Variable invar("i");
	Variable outvar("o");

	Variable quit("quit");

	cout << invar << outvar << endl;

	cin.get();

	Type* aktKey = new IntegerType ();
	Type* aktValue = new ExprType ();

	invar->set(makeHashTable(*aktKey, *aktValue));
	outvar->set(makeHashTable(*aktKey, *aktValue));

	delete aktKey;
	delete aktValue;
	
	bool exit = false; 

	const char* vl1[] = {"x", "y"}; 
	const char* vl2[] = {"u"}; 


	PolynomialRing rA(new PolynomialRingRep(IntegerRing::integerRing,VarList(2,vl1)));
	PolynomialRing rB(new PolynomialRingRep(IntegerRing::integerRing,VarList(1,vl2)));
	PolynomialRing rC(new PolynomialRingRep(rB,VarList(2,vl1)));


	Polynomial p1(new PolynomialRep(rA,Symbol("x")));
	Polynomial p2(new PolynomialRep(rA,Symbol("y")));
	Polynomial p3(new PolynomialRep(rC,Symbol("y")));

	RingMap f(new RingMapPolyRep()); 
	
	Polynomial pp(Integer(1));

	f->apply(pp);

	cout << pp << endl;
	cout << "p1 = " << p1 << endl;
	cout << "p2 = " << p2 << endl;

	cout << "Summen" << endl;

	cout << "p1 + p1 = " << p1 + p1 << endl;
	cout << "p1 * p1 = " << p1 * p1 << endl;
	cout << "p2 * p2 = " << p2 * p2 << endl;

	Polynomial p4 = p1 + p2;

	cout << "p1 = " << p1 << endl;
	cout << "p2 = " << p2 << endl;

	Polynomial pp4 = p1 * p1 * p1 * p1;
	Polynomial pp3 = p1 * p1 * p1;
	Polynomial pp2 = p1 * p1;
	Polynomial pp1 = p1;
	Polynomial pp0(new PolynomialRep(rA, Integer(-1)));

	Polynomial ppA = pp4 + pp2;
	Polynomial ppB = pp3 + pp1;
	Polynomial ppC = pp3 + pp0;
	Polynomial ppD = pp1 + pp0;

	Polynomial ppAB = ppA + ppB;
	Polynomial ppAC = ppA + ppC;
	Polynomial ppAD = ppA + ppD;
	
	Polynomial ppBC = ppB + ppC;
	Polynomial ppCB = ppC + ppB;

	cout << "ppAB = " << ppAB << endl;
	cout << "ppAC = " << ppAC << endl;
	cout << "ppAD = " << ppAD << endl;
	cout << "ppBC = " << ppBC << endl;
	cout << "ppCB = " << ppCB << endl;

	p4 = p1 + pp0 * p2;

	cout << "(x - y)^4 = " << p4 * p4 * p4 * p4 << endl;

	cout << "sq ( sq (x-y) ) = " << sq(sq(p4)) << endl;

	cout << endl;

	cout << pp->getRing() << endl;

	cin.get();


	cout << IntegerRing::integerRing->commonOverRing(IntegerRing::integerRing) << endl;
	cout << rA->commonOverRing(IntegerRing::integerRing) << endl;
	cout << IntegerRing::integerRing->commonOverRing(rA) << endl;
	cout << rA->commonOverRing(rB) << endl;

	cin.get();

	cout << rC << endl;

	cout << (rA == rB) << endl;
	cout << (rA == rA) << endl;
	cout << (rC == rC) << endl;
	cout << (rC == rB) << endl;
	cout << (IntegerRing::integerRing == IntegerRing::integerRing) << endl;
	cout << (IntegerRing::integerRing == rA) << endl;

	cin.get();

	while (! exit) {
		
		string eeStr;

		Integer lc (lineCnt);

		cout << invar << "[" << lc << "] = "; 
		cin >> eeStr;

		Variable eeVar(eeStr);


		invar[lc] = eeVar;

		Expr ff = eeVar.eval ();

		outvar[lc] = ff;
	
		if (static_cast<VariableRep*>(ff.getRep())->getName() == "quit") {
			exit = true;
		};

//		Polynomial pol;
		RingElem sqarg = lc;

		cout << endl;
		cout << outvar << "[" << lc << "] = ";
		cout << outvar[lc] << endl;

		Integer p = lc * lc;
		cout << "lc after * = " << lc << endl;
		Expr s = lc + lc;
		cout << "lc after + = " << lc << endl;
		cout << "sq () = " << sq(sqarg) << endl;

		cout << "( " << lc << " )^2 = " << p << " + = " << s <<endl << endl;
		
		lineCnt++;
	};

	}
	cin.get();
	cout << endl;
	cout << "Polynomial Ring Instance Count = " << PolynomialRep::instanceCount << endl;
	cout << endl;
	cin.get();

	return 0;
}

