#include "StdAfx.h"
#include "VarList.h"

#include "Monomial.h"

using namespace std;

VarList::VarList(void)
{
}

VarList::~VarList(void)
{
}

VarList::VarList(int nvars) {

	for (int i = 0; i < nvars; ++i) {
		symlist.push_back (Symbol(string("$")));
	};
}

VarList::VarList(int nvars, const char* anamelis[]) {

	for (int i = 0; i < nvars; ++i) {
		symlist.push_back( Symbol(string(anamelis[i])) );
	};

}

ostream& VarList::print(ostream& os) const {

	VSCI p = symlist.begin();
	VSCI q = symlist.end();
	bool empty = (p == q);

	if (! empty)
		--q;

	for ( p = p; p != q; ++p) {
		os << *p << ",";
	};
	if (! empty)
		os << *q;

	return os;

}

ostream& operator<< (ostream& os, const VarList& varLis) {

	return varLis.print (os);

}

Monomial VarList::makeMonomial(const Symbol& x) {

	Monomial m(symlist.size());

	VSCI p;
	int pos;

	for (p = symlist.begin(), pos = 0; p != symlist.end(); ++p, ++pos) {
		if (x == *p)
			m.setPos(pos);
	};

	return m;
}

bool operator== (const VarList& vl1, const VarList& vl2) {

	bool eqq = (vl1.symlist.size() == vl2.symlist.size());

	if (eqq) {

		VarList::VSCI p = vl1.symlist.begin();
		VarList::VSCI q = vl2.symlist.begin();
		VarList::VSCI pe = vl1.symlist.end();

		while (eqq && (p != pe)) {
			eqq = eqq && (*p == *q);
			++p;
			++q;
		};
	};

	return eqq;
}
